/*===========================================================================
				    .
===========================================================================*/
#include <16F628A.h>
#use delay(clock=20000000)
#use standard_IO(A,B)
#use i2c(Master,sda=PIN_B3,scl=PIN_B6,RESTART_WDT,SLOW)
#fuses HS, NOWDT, NOLVP, NOBROWNOUT, NOMCLR
/*---------------------------------------------------------------------------
									.
---------------------------------------------------------------------------*/
#define CLK	output_bit(PIN_B2,1);delay_us(1);output_bit(PIN_B2,0);
#define DATA_Out PIN_B3

#define Ind_Digit_1 output_low(PIN_B4);buttons();delay_ms(1);output_high(PIN_B4);
#define Ind_Digit_2 output_low(PIN_B5);buttons();delay_ms(1);output_high(PIN_B5);
#define Ind_Digit_3 output_low(PIN_B6);buttons();delay_ms(1);output_high(PIN_B6);
#define Ind_Digit_4 output_low(PIN_B7);buttons();delay_ms(1);output_high(PIN_B7);

#define IN_Dig_Taxo WORD_to_BCD(Taxo[1]);Digit_1[1]=num[3];Digit_1[2]=num[4];Digit_1[3]=0;Digit_1[4]=0;
#define IN_Dig_Dlit WORD_to_HEX(Dlit[0]);Digit_1[1]=num[1];Digit_1[2]=num[2];Digit_1[3]=num[3];Digit_1[4]=num[4];

#define LOAD_DIG_1 Digit_1[0]=Digit_1[d];tablica_simbols();Ind[0]=Digit_1[0];

#define Num_0 num[0]=value;num[1]=0;num[2]=0;num[3]=0;num[4]=0;low=num[0];high=0;num[4]=low;
#define Num_1 high++;low -= 10;num[1] = low;num[0] = high;
#define Num_2 high++;low -= 10;num[2] = low;num[1] = high;
#define Num_3 high++;low -= 10;num[3] = low;num[2] = high;
#define Num_4 high++;low -= 10;num[4] = low;num[3] = high;
#define Num_5 low = high; high = 0;

#define ON output_high(PIN_A2);
#define OFF output_low(PIN_A2);
/*---------------------------------------------------------------------------
								 
---------------------------------------------------------------------------*/
unsigned char Const_1[] = {0,8,7,6,5,4,4,3,3,3,3,2,2,2,2,2,2,2,1,1,1,1,1,1,
																 1,0,0,0,0};
unsigned char Const_2[] = {1,0xD3,0x5A,0x4C,0x81,0xE2,0x64,0xFB,0xA4,0x5B,
	0x1C,0xE5,0xB5,0x8B,0x65,0x43,0x25,0x09,0xF0,0xD9,0xC4,0xB0,0x61,0x2B,
	0x01,0xE2,0xC7,0xB3,0xA1};
unsigned char Const_3[] = {0,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
									   21,22,23,24,25,30,35,40,45,50,55,60};
unsigned char Digit_1[] = {0,0,0,0,0};	// .    .
unsigned char Ind[] = {0};
unsigned char c = 0;
unsigned char d = 0;					// d -   .
unsigned int16 num[] = {0,0,0,0,0};		//  .
unsigned char Cnt_Button = 0;			//    .
unsigned char Taxo[] = {6,0};
unsigned int16 Msec[] = {0,0};
unsigned int16 Var[] = {0};
/*===========================================================================
								  TMR2.
===========================================================================*/
#int_TIMER2
void  TIMER2_isr(void) 
{
	set_timer2(250);
	Msec[0]++;
	if (Msec[0] >= Var[0])
	{
		Msec[0] = 0;
		if (Taxo[0] > 0)
		{
			OFF
			delay_us(100);
			ON
		}
	}
}
/*===========================================================================
								.
===========================================================================*/
void WORD_to_BCD(unsigned int16 value);
void read_memory();
void write_memory();
void indic();
void buttons();
void Indicator(unsigned char value);
void tablica_simbols();
/*=========================================================================*/
void main (void)
{
	port_b_pullups(0xFF);			//   
									//   .
	set_tris_a(0x20);				// RA5 - ,  
	set_tris_b(0x85);				// RB3, RB1 - ,  .
	output_high(PIN_B1);
	Taxo[1] = Const_3[Taxo[0]]; 	//  .	
	Var[0] = Const_1[Taxo[0]] << 8;
	Var[0] = Var[0] + Const_2[Taxo[0]];
/*===========================================================================
								 .
===========================================================================*/
	do
	{
		indic();					//  .
		if (Cnt_Button > 0)
		{
			Cnt_Button--;			//    .
		}
		setup_timer_2(T2_DIV_BY_16, 255, 1);
		enable_interrupts(INT_TIMER2);
		enable_interrupts(GLOBAL);
	}
	while(1);
} 
/*===========================================================================
						    .
===========================================================================*/
void indic()
{
	for (d = 1; d < 5; d++)
	{
/*-------------------------------------------------------------------------*/
		IN_Dig_Taxo
		LOAD_DIG_1
		switch(d)
		{
			case 1: bit_set(Ind[0],0); break;	//    1 .
		}
/*-------------------------------------------------------------------------*/
		Indicator(Ind[0]);
		switch(d)
		{
			case 1: Ind_Digit_1; break;
			case 2: Ind_Digit_2; break;
			case 3: Ind_Digit_3; break;
			case 4: Ind_Digit_4; break;
		}
/*-------------------------------------------------------------------------*/
	}
	return;
}
/*===========================================================================
								  .
===========================================================================*/
void buttons()
{
	if (Cnt_Button == 0)
	{
		switch(d)
		{
			case 1:
			{
				if (input(PIN_A0) == 0)				// SB_2  +.
				{
					Taxo[0]++; 
					if (Taxo[0] >= 29) 
					{
						Taxo[0] = 0;
					}
					Taxo[1] = Const_3[Taxo[0]]; 
					Var[0] = Const_1[Taxo[0]] << 8;
					Var[0] = Var[0] + Const_2[Taxo[0]];
					Cnt_Button = 100;
				}
				if (input(PIN_A1) == 0)				// SB_3  -.
				{
					Taxo[0]--; 
					if (Taxo[0] == 0xFF) 
					{
						Taxo[0] = 28;
					}
					Taxo[1] = Const_3[Taxo[0]]; 
					Var[0] = Const_1[Taxo[0]] << 8;
					Var[0] = Var[0] + Const_2[Taxo[0]];
					Cnt_Button = 100;
				}
			}
			break;
		}
	}
	return ;
}
/*===========================================================================
							 .
===========================================================================*/
void tablica_simbols()
{													// GBFA CDEH 
	switch(Digit_1[0])
	{
		case  0: Digit_1[0] = 0x7E; break;
		case  1: Digit_1[0] = 0x48; break;
		case  2: Digit_1[0] = 0xD6; break;
		case  3: Digit_1[0] = 0xDC; break;
		case  4: Digit_1[0] = 0xE8; break;
		case  5: Digit_1[0] = 0xBC; break;
		case  6: Digit_1[0] = 0xBE; break;
		case  7: Digit_1[0] = 0x58; break;
		case  8: Digit_1[0] = 0xFE; break;
		case  9: Digit_1[0] = 0xFC; break;
		case 10: Digit_1[0] = 0xFA; break;			// A.
		case 11: Digit_1[0] = 0xAE; break;			// b.
		case 12: Digit_1[0] = 0x36; break;			// C.
		case 13: Digit_1[0] = 0xCE; break;			// d.
		case 14: Digit_1[0] = 0xB6; break;			// E.
		case 15: Digit_1[0] = 0xB2; break;			// F.
		case 16: Digit_1[0] = 0x00; break;			// ' ' - .
		case 17: Digit_1[0] = 0x80; break;			// '-' - .
	}
	return;
}
/*===========================================================================
						    .
===========================================================================*/
void Indicator(unsigned char value) 
{
	c = 8;
	while (c)
	{
		output_bit(DATA_Out,value & 1);           
		delay_us(1);
		value >>= 1;
		CLK          
		c--;
	}
	return;
}
/*===========================================================================
                         BCD e.
===========================================================================*/
void WORD_to_BCD(unsigned int16 value)
{
unsigned int16 high = 0;	// .    .
unsigned int16 low = 0;

		Num_0
	while (num[4] >= 10)
	{
		Num_4
	}
	Num_5
	while (num[3] >= 10)
	{
		Num_3
	}
	Num_5
	while (num[2] >= 10)
	{
		Num_2
	}
	Num_5
	num[0] = 0;
	while (num[1] >= 10)
	{
		Num_1
	}
	return;
}
/*========================================================================*/
